Subject: Re: [PATCH v2 05/12] arm64: Basic Branch Target Identification support

From: Dave Martin <[email-masked]>
Date: Fri, 11 Oct 2019 16:44:45 +0100

On Fri, Oct 11, 2019 at 04:40:43PM +0100, Mark Rutland wrote:
> On Fri, Oct 11, 2019 at 04:32:26PM +0100, Dave Martin wrote:
> > On Fri, Oct 11, 2019 at 11:25:33AM -0400, Richard Henderson wrote:
> > > On 10/11/19 11:10 AM, Mark Rutland wrote:
> > > > On Thu, Oct 10, 2019 at 07:44:33PM +0100, Dave Martin wrote:
> > > >> @@ -730,6 +730,11 @@ static void setup_return
> > > >>  	regs->regs[29] = (unsigned long)&user->next_frame->fp;
> > > >>  	regs->pc = (unsigned long)ka->sa.sa_handler;
> > > >>  
> > > >> +	if (system_supports_bti()) {
> > > >> +		regs->pstate &= ~PSR_BTYPE_MASK;
> > > >> +		regs->pstate |= PSR_BTYPE_CALL;
> > > >> +	}
> > > >> +
> > > > 
> > > > I think we might need a comment as to what we're trying to ensure here.
> > > > 
> > > > I was under the (perhaps mistaken) impression that we'd generate a
> > > > pristine pstate for a signal handler, and it's not clear to me that we
> > > > must ensure the first instruction is a target instruction.
> > > 
> > > I think it makes sense to treat entry into a signal handler as a call.  Code
> > > that has been compiled for BTI, and whose page has been marked with PROT_BTI,
> > > will already have the pauth/bti markup at the beginning of the signal handler
> > > function; we might as well verify that.
> > > 
> > > Otherwise sigaction becomes a hole by which an attacker can force execution to
> > > start at any arbitrary address.
> > 
> > Ack, that's the intended rationale -- I also outlined this in the commit
> > message.
> 
> Ah, sorry. I evidently did not read that thoroughly enough.
> 
> > Does this sound reasonable?
> > 
> > 
> > Either way, I feel we should do this: any function in a PROT_BTI page
> > should have a suitable landing pad.  There's no reason I can see why
> > a protection given to any other callback function should be omitted
> > for a signal handler.
> > 
> > Note, if the signal handler isn't in a PROT_BTI page then overriding
> > BTYPE here will not trigger a Branch Target exception.
> > 
> > I'm happy to drop a brief comment into the code also, once we're
> > agreed on what the code should be doing.
> 
> So long as there's a comment as to why, I have no strong feelings here.
> :)

OK, I think it's worth a brief comment in the code either way, so I'll
add something.

Cheers
---Dave

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel